VERSION 5.00
Begin VB.UserControl HyperLink 
   AutoRedraw      =   -1  'True
   BackStyle       =   0  'Transparent
   ClientHeight    =   1035
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   3465
   PropertyPages   =   "MyHyperLink.ctx":0000
   ScaleHeight     =   1035
   ScaleWidth      =   3465
   ToolboxBitmap   =   "MyHyperLink.ctx":0040
   Begin VB.Timer Timer1 
      Interval        =   100
      Left            =   2355
      Top             =   90
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "HyperLink"
      BeginProperty Font 
         Name            =   "Tahoma"
         Size            =   12
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   285
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   1245
   End
End
Attribute VB_Name = "HyperLink"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "PropPageWizardRun" ,"Yes"
Option Explicit

Public Enum LabelMode
  [Text Mode] = 0
  [Image Mode] = 1
End Enum

'Private types
Private Type POINTAPI
    X As Long
    Y As Long
End Type

'Public enums
Public Enum MyAppearance
  [Flat] = 0
  [3D] = 1
End Enum

Public Enum MyBorderStyle
  [None] = 0
  [Fixed Single] = 1
End Enum


'Private constants for sndPlaySound
Private Const SND_ASYNC = &H1
Private Const SND_NODEFAULT = &H2
Private Const SND_MEMORY = &H4
Private SoundArray() As Byte
'Private function declarations
Private Declare Function GetCursorPos Lib "user32" (lpPoint As POINTAPI) As Long
Private Declare Function WindowFromPoint Lib "user32" (ByVal xPoint As Long, ByVal yPoint As Long) As Long
Private Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hwnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long
Private Declare Function sndPlaySound Lib "winmm.dll" Alias "sndPlaySoundA" (lpszSoundName As Byte, ByVal uFlags As Long) As Long

Dim sHyperLink As String

Dim pCursorPos As POINTAPI
Dim uMode As LabelMode
Dim uMouseOver As Boolean

Dim uForeColor As OLE_COLOR
Dim uForeColorDown As OLE_COLOR
Dim uForeColorOver As OLE_COLOR

Dim uBackColor As OLE_COLOR
Dim uBackColorDown As OLE_COLOR
Dim uBackColorOver As OLE_COLOR

Dim uImage As StdPicture
Dim uImageOver As StdPicture
Dim uImageDown As StdPicture

Dim uMouseIcon As StdPicture
Dim uAutosize As Boolean
Public Event StatusChanged(NewStatus As Integer)
'Default Property Values:
Const m_def_ForeColor = &H80000012
'Property Variables:
Dim m_ForeColor As OLE_COLOR
Dim m_Font As Font
'Event Declarations:
Event Click() 'MappingInfo=Label1,Label1,-1,Click
Attribute Click.VB_Description = "Occurs when the user presses and then releases a mouse button over an object."
Attribute Click.VB_MemberFlags = "200"
Event DblClick() 'MappingInfo=Label1,Label1,-1,DblClick
Attribute DblClick.VB_Description = "Occurs when the user presses and releases a mouse button and then presses and releases it again over an object."
Event MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single) 'MappingInfo=Label1,Label1,-1,MouseDown
Attribute MouseDown.VB_Description = "Occurs when the user presses the mouse button while an object has the focus."
Event MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single) 'MappingInfo=Label1,Label1,-1,MouseMove
Attribute MouseMove.VB_Description = "Occurs when the user moves the mouse."
Event MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single) 'MappingInfo=Label1,Label1,-1,MouseUp
Attribute MouseUp.VB_Description = "Occurs when the user releases the mouse button while an object has the focus."

Private Sub Timer1_Timer()
  Dim Status As Long
  Dim CurrenthWnd As Long
  
  Timer1.Enabled = False
  
  Status = GetCursorPos&(pCursorPos)
  CurrenthWnd = WindowFromPoint(pCursorPos.X, pCursorPos.Y)
  
  If uMouseOver = False Then
    If CurrenthWnd = UserControl.hwnd Then
      uMouseOver = True
      Label1.ToolTipText = ToolTipText
      If uMode = [Text Mode] Then
        Label1.BackColor = uBackColorOver
        Label1.ForeColor = uForeColorOver
      Else
        Set UserControl.Picture = uImageOver
      End If
      RaiseEvent StatusChanged(1)
    End If
  Else
    If CurrenthWnd <> UserControl.hwnd Then
      uMouseOver = False
      If uMode = [Text Mode] Then
        Label1.ForeColor = uForeColor
        Label1.BackColor = uBackColor
      Else
        Set UserControl.Picture = uImage
      End If
      RaiseEvent StatusChanged(0)
    End If
  End If
  
  Timer1.Enabled = True
End Sub

Private Sub UserControl_Click()
   Call Label1_Click
End Sub

Private Sub UserControl_DblClick()
  Call Label1_DblClick
  
End Sub

Private Sub UserControl_Initialize()
  uMode = [Text Mode]
  uAutosize = True
  uMouseOver = False
End Sub

Private Sub UserControl_InitProperties()
  Timer1.Enabled = Ambient.UserMode
  ForeColor = vbWhite
  BackColor = vbBlue
  ForeColorOver = vbYellow
  BackColorOver = vbRed
  MyHyperLink = "www.yourlinkhere.com"
  Caption = Ambient.DisplayName
  Call ReSize
End Sub

Private Sub UserControl_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
  Call Label1_MouseDown(Button, Shift, X, Y)
  
End Sub

Private Sub UserControl_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
  Call Label1_MouseMove(Button, Shift, X, Y)
  
End Sub

Private Sub UserControl_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
  Call Label1_MouseUp(Button, Shift, X, Y)
  
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
  'turn the timer off when in design mode
  Timer1.Enabled = Ambient.UserMode
  
  LabelMode = PropBag.ReadProperty("LabelMode", [Text Mode])
  Appearance = PropBag.ReadProperty("Appearance", [3D])
  BorderStyle = PropBag.ReadProperty("BorderStyle", [Fixed Single])
  ForeColorOver = PropBag.ReadProperty("ForeColorOver", vbYellow)
  ForeColor = PropBag.ReadProperty("ForeColor", vbWhite)
  BackColor = PropBag.ReadProperty("BackColor", vbBlue)
  BackColorOver = PropBag.ReadProperty("BackColorOver", vbRed)
  AutoSize = PropBag.ReadProperty("AutoSize", True)
  MousePointer = PropBag.ReadProperty("MousePointer", 0)
  Set Font = PropBag.ReadProperty("Font", Ambient.Font)
  Set MouseIcon = PropBag.ReadProperty("MouseIcon", Nothing)
  Set Image = PropBag.ReadProperty("Image", Nothing)
  Set ImageOver = PropBag.ReadProperty("ImageOver", Nothing)
  Caption = PropBag.ReadProperty("Caption", Ambient.DisplayName)
  Enabled = PropBag.ReadProperty("Enabled", True)
  ToolTipText = PropBag.ReadProperty("ToolTipText", "")
  MyHyperLink = PropBag.ReadProperty("MyHyperLink", "www.yourlinkhere.com")
  
End Sub

Private Sub UserControl_Resize()
  Call ReSize
  
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
  Call PropBag.WriteProperty("LabelMode", LabelMode, [Text Mode])
  Call PropBag.WriteProperty("Appearance", Appearance, [3D])
  Call PropBag.WriteProperty("BorderStyle", BorderStyle, [Fixed Single])
  Call PropBag.WriteProperty("BackColor", BackColor, vbBlue)
  Call PropBag.WriteProperty("Font", Font, Ambient.Font)
  Call PropBag.WriteProperty("ForeColorOver", ForeColorOver, vbYellow)
  Call PropBag.WriteProperty("ForeColor", ForeColor, vbWhite)
  Call PropBag.WriteProperty("BackColorOver", BackColorOver, vbRed)
  Call PropBag.WriteProperty("MouseIcon", MouseIcon, Nothing)
  Call PropBag.WriteProperty("MousePointer", MousePointer, 0)
  Call PropBag.WriteProperty("Image", Image, Nothing)
  Call PropBag.WriteProperty("AutoSize", AutoSize, True)
  Call PropBag.WriteProperty("ImageOver", ImageOver, Nothing)
  Call PropBag.WriteProperty("Caption", Caption, Ambient.DisplayName)
  Call PropBag.WriteProperty("Enabled", Enabled, True)
  Call PropBag.WriteProperty("ToolTipText", ToolTipText, "")
  Call PropBag.WriteProperty("MyHyperLink", MyHyperLink, "www.yourlinkhere.com")
  
End Sub

Public Property Get BorderStyle() As MyBorderStyle
Attribute BorderStyle.VB_ProcData.VB_Invoke_Property = ";Appearance"
    BorderStyle = Label1.BorderStyle

End Property

Public Property Let BorderStyle(ByVal vNewValue As MyBorderStyle)
  If vNewValue = [Fixed Single] Or vNewValue = None Then
    Label1.BorderStyle = vNewValue
    Call ReSize
    PropertyChanged "BorderStyle"
  Else
    Err.Raise Number:=vbObjectError + 9999, Description:="Invalid BorderStyle 0 or 1 only."
  End If
  
End Property
Public Property Get LabelMode() As LabelMode
Attribute LabelMode.VB_ProcData.VB_Invoke_Property = ";Behavior"
  LabelMode = uMode
  
End Property

Public Property Let LabelMode(ByVal vNewValue As LabelMode)
  If vNewValue = [Text Mode] Or vNewValue = [Image Mode] Then
    uMode = vNewValue
    If uMode = [Image Mode] Then
      Label1.Visible = False
      'set the control to opaque
      UserControl.BackStyle = 1
    End If
    
    If uMode = [Text Mode] Then
      Label1.Visible = True
    End If
    Call ReSize
    PropertyChanged "LabelMode"
  Else
    Err.Raise Number:=vbObjectError + 9999, Description:="Invalid value 0 or 1 only."
  End If
  
End Property

Public Property Get Font() As StdFont
Attribute Font.VB_ProcData.VB_Invoke_Property = ";Appearance"
  Set Font = Label1.Font
End Property

Public Property Set Font(ByVal vNewValue As StdFont)
  Set Label1.Font = vNewValue
  Call ReSize
  PropertyChanged "Font"

End Property

Public Property Get ForeColor() As OLE_COLOR
Attribute ForeColor.VB_ProcData.VB_Invoke_Property = ";Appearance"
  ForeColor = Label1.ForeColor

End Property

Public Property Let ForeColor(ByVal New_ForeColor As OLE_COLOR)
  Label1.ForeColor = New_ForeColor
  uForeColor = New_ForeColor
  PropertyChanged "ForeColor"

End Property

Public Property Get ForeColorOver() As OLE_COLOR
Attribute ForeColorOver.VB_ProcData.VB_Invoke_Property = ";Appearance"
  ForeColorOver = uForeColorOver
  
End Property

Public Property Let ForeColorOver(ByVal vNewValue As OLE_COLOR)
  uForeColorOver = vNewValue
  PropertyChanged "ForeColorOver"
  
End Property

Public Property Get BackColorOver() As OLE_COLOR
Attribute BackColorOver.VB_ProcData.VB_Invoke_Property = ";Appearance"
  BackColorOver = uBackColorOver
  
End Property

Public Property Let BackColorOver(ByVal vNewValue As OLE_COLOR)
  uBackColorOver = vNewValue
  PropertyChanged "BackColorOver"
  
End Property

Public Property Get BackColor() As OLE_COLOR
Attribute BackColor.VB_ProcData.VB_Invoke_Property = ";Appearance"
  BackColor = Label1.BackColor
  
End Property

Public Property Let BackColor(ByVal vNewValue As OLE_COLOR)
  Label1.BackColor = vNewValue
  uBackColor = vNewValue
  PropertyChanged "BackColor"
  
End Property

Public Property Get MouseIcon() As Picture
Attribute MouseIcon.VB_Description = "Sets a custom mouse icon."
Attribute MouseIcon.VB_ProcData.VB_Invoke_Property = ";Appearance"
  Set MouseIcon = Label1.MouseIcon
End Property

Public Property Set MouseIcon(ByVal New_MouseIcon As Picture)
  Set Label1.MouseIcon = New_MouseIcon
  PropertyChanged "MouseIcon"
End Property

Public Property Get MousePointer() As MousePointerConstants
Attribute MousePointer.VB_Description = "Returns/sets the type of mouse pointer displayed when over part of an object."
Attribute MousePointer.VB_ProcData.VB_Invoke_Property = ";Appearance"
  MousePointer = Label1.MousePointer
End Property

Public Property Let MousePointer(ByVal New_MousePointer As MousePointerConstants)
  Label1.MousePointer() = New_MousePointer
  PropertyChanged "MousePointer"
End Property

Public Property Get Image() As Picture
Attribute Image.VB_Description = "Returns/sets a graphic to be displayed in a control."
Attribute Image.VB_ProcData.VB_Invoke_Property = ";Appearance"
  Set Image = UserControl.Picture
End Property

Public Property Set Image(ByVal New_Picture As Picture)
  Set UserControl.Picture = New_Picture
  Set uImage = New_Picture
  'if new_picture is nothing then set the label back to text mode
  If New_Picture Is Nothing Then
    LabelMode = [Text Mode]
    'clear all the pictues
    Set ImageOver = Nothing
  Else
    LabelMode = [Image Mode]
  End If
  Call ReSize
  PropertyChanged "Image"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=Label1,Label1,-1,AutoSize
Public Property Get AutoSize() As Boolean
Attribute AutoSize.VB_Description = "Determines whether a control is automatically resized to display its entire contents."
Attribute AutoSize.VB_ProcData.VB_Invoke_Property = "Settings;Behavior"
  AutoSize = Label1.AutoSize
  
End Property

Public Property Let AutoSize(ByVal New_AutoSize As Boolean)
  Label1.AutoSize() = New_AutoSize
  uAutosize = New_AutoSize
  Call ReSize
  PropertyChanged "AutoSize"
  
End Property

Public Property Get ImageOver() As StdPicture
Attribute ImageOver.VB_ProcData.VB_Invoke_Property = ";Appearance"
  Set ImageOver = uImageOver
  
End Property

Public Property Set ImageOver(ByVal vNewValue As StdPicture)
  Set uImageOver = vNewValue
  PropertyChanged "ImageOver"
  
End Property

Private Sub ReSize()
  If uMode = [Text Mode] Then
    If uAutosize Then
      UserControl.Width = Label1.Width
      UserControl.Height = Label1.Height
    Else
      Label1.Width = UserControl.Width
      Label1.Height = UserControl.Height
    End If
  End If
  
End Sub


'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=Label1,Label1,-1,Caption
Public Property Get Caption() As String
Attribute Caption.VB_Description = "Returns/sets the text displayed in an object's title bar or below an object's icon."
Attribute Caption.VB_ProcData.VB_Invoke_Property = "Settings;Appearance"
  Caption = Label1.Caption
End Property

Public Property Let Caption(ByVal New_Caption As String)
  Label1.Caption() = New_Caption
  Call ReSize
  PropertyChanged "Caption"
End Property

Private Sub Label1_Click()
  Dim lReturn As Long
  'Execute the link's default program
  lReturn = ShellExecute(0&, "Open", sHyperLink, "", vbNullString, 1)

  RaiseEvent Click
End Sub

Private Sub Label1_DblClick()
  RaiseEvent DblClick
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,Enabled
Public Property Get Enabled() As Boolean
Attribute Enabled.VB_Description = "Returns/sets a value that determines whether an object can respond to user-generated events."
Attribute Enabled.VB_ProcData.VB_Invoke_Property = "Settings;Behavior"
Attribute Enabled.VB_UserMemId = -514
  Enabled = UserControl.Enabled
End Property

Public Property Let Enabled(ByVal New_Enabled As Boolean)
  UserControl.Enabled() = New_Enabled
  PropertyChanged "Enabled"
End Property

Private Sub Label1_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
  RaiseEvent MouseDown(Button, Shift, X, Y)
End Sub

Private Sub Label1_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
  RaiseEvent MouseMove(Button, Shift, X, Y)
End Sub

Private Sub Label1_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
  RaiseEvent MouseUp(Button, Shift, X, Y)
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=Label1,Label1,-1,ToolTipText
Public Property Get ToolTipText() As String
Attribute ToolTipText.VB_Description = "Returns/sets the text displayed when the mouse is paused over the control."
Attribute ToolTipText.VB_ProcData.VB_Invoke_Property = "Settings;Appearance"
  ToolTipText = Label1.ToolTipText
End Property

Public Property Let ToolTipText(ByVal New_ToolTipText As String)
  Label1.ToolTipText() = New_ToolTipText
  PropertyChanged "ToolTipText"
End Property

Public Property Get MyHyperLink() As String
Attribute MyHyperLink.VB_ProcData.VB_Invoke_Property = "Settings"
  MyHyperLink = sHyperLink
  
End Property

Public Property Let MyHyperLink(ByVal vNewValue As String)
  sHyperLink = vNewValue
  PropertyChanged "MyHyperLink"
  
End Property
Public Sub ShowAbout()
Attribute ShowAbout.VB_UserMemId = -552
  frmAbout.Show vbModal
  
End Sub
